#include <string.h>
#include <stdlib.h>
#include <ssdef.h>
#include "global.h"
#include "list.h"
#include "constants.h"
#include "window.h"

extern int sys$setast(int);

void init_head(top, max)
  head_ptr top;
  int max;
{
  top->newest = NULL;
  top->curr = NULL;
  top->oldest = NULL;
  top->count = 0;
  top->max = max;
}

extern server_ptr gsrv;
struct head_struct input;

void set_list_limit(head_ptr list, int limit)
{
  int change;
  list_ptr temp;
  int loop;

  if (limit<0) limit = 0;
  change = list->count - limit;
  list->max = limit;
  if (list->count > limit) list->count = limit;
  for (loop=0;loop<change;loop++)
  {
    temp = list->oldest;
    list->oldest = list->oldest->newer;
    list->oldest->older = NULL;
    if (list->curr == temp) list->curr = list->oldest;
    if (list->newest == temp) list->newest = list->oldest;
    myfree(temp);
  }
}

void set_hist_limit(int max)
{
  int old;
  old = sys$setast(0);
  yell("hist limit to %d", max);
  set_list_limit(&input, max);
  if (old == SS$_WASSET) sys$setast(1);
}

void init_input_list(int max)
{
  init_head(&input, max);
}

void add_list(list, str, type)
  head_ptr list;
  char *str;
  int type;
{
  list_ptr temp;
  int size;

  size = sizeof(struct list_struct) + strlen(str) + 1;
  if ((temp = (list_ptr)mymalloc(size)) == NULL) {
    say("Could not allocate space for malloc - add_list");
    return;
  }
  temp->text = (char *)((int)temp + sizeof(struct list_struct));
  (void)strcpy(temp->text, str);
  temp->type = type;
  temp->newer = NULL;
  temp->older = list->newest;
   
  if (list->newest) list->newest->newer = temp;
  if (!list->oldest) list->oldest = temp;
  list->newest = temp;
  list->curr = NULL;
  (list->count)++;
  set_list_limit(list, list->max);
}

void add_input_list(str)
  char *str;
{
  int old;
  old = sys$setast(0);
  add_list(&input, str, 0);
  if (old == SS$_WASSET) sys$setast(1);
}

void get_prev_input(str, older)
  char *str;
  int older;
{
  if (older) {
    if (!input.curr) input.curr = input.newest;
    else input.curr = input.curr->older;
    if (!input.curr) input.curr = input.newest;
  } else {
    if (!input.curr) input.curr = input.oldest;
    else input.curr = input.curr->newer;
    if (!input.curr) input.curr = input.oldest;
  }
  if (input.curr) (void)strcpy(str, input.curr->text);
  else str[0] = 0;
}
